
#include "bits/bitsperlong.h"

#include "fxtio.h"


void
bitpol_print(const char *bla, ulong c, int texq/*=0*/)
{
    if ( texq ) cout << "$";
    if ( bla )  cout << bla;
    ulong i = BITS_PER_LONG-1;
    ulong t = 1UL<<i;
    while ( c )
    {
        ulong q = c & t;
        if ( q )
        {
            c ^= q;
            if ( i<=1 )  cout << (i ? "x" : "1");
            else
            {
                cout << "x^";
                if ( texq ) cout << "{";
                cout << i;
                if ( texq ) cout << "}";
            }
            if ( c )  cout << (texq ? "+" : " + ");
        }
        t>>=1;
        --i;
    }
    if ( texq ) cout << "$";
}
// -------------------------


void
bitpol_print_factorization(const ulong *f, const ulong *e, ulong fct)
{
    for (ulong i=0; i<fct; ++i)
    {
        cout << " (";
        bitpol_print(0,f[i],0);
        cout << ")";
        cout << "^";
        cout << e[i];
    }
}
// -------------------------
