
#include "bits/greencode.h"
#include "bits/bitrotate.h"

#define TEST_SOLUTION
#ifdef TEST_SOLUTION
#include "jjassert.h"
#endif


ulong
normal_solve_reduced_quadratic(ulong c, ulong n)
// Solve x^2 + x = c
// Must have:  trace(c)==0
// Return one solution x, the other solution equals 1+x
{
    ulong x = inverse_green_code(c);
    x &= (1UL<<(n-1))-1;

#ifdef TEST_SOLUTION
    ulong t = bit_rotate_left(x, 1, n);
    t ^= x;  // t = x^2+x
    t ^= c;  // t = x^2+x+c == 0
//    print_bin_nn(" t=", t, n);
    jjassert( 0==t );
#endif // TEST_SOLUTION

    return  x;
}
// -------------------------
