
#include "bits/bitcombminchange.h"
#include "bits/greencode.h"

#include "fxttypes.h"
#include "bits/printbin.h"
#include "jjassert.h"

#include "fxtio.h"
#include <cstdlib>  // strtoul()

//% Generating combinations of bits (as binary words) in minimal-change order.


void
foo(ulong n, ulong k)
{
    cout << " n = " << n << "  k = " << k << endl;
    jjassert( n>0 );
    jjassert( k>0 );
    jjassert( n>=k );

    const ulong pd = n;
    ulong last = igc_last_comb(k, n);
    ulong c, nc = first_sequency(k);
    do
    {
        c = nc;
        nc = igc_next_minchange_comb(c);

        ulong g = gray_code(c);

        print_bin_nn("  ", g, pd);
        print_bin_nn("  ", c, pd);
        print_bin_nn("  ", nc-c, pd);

        cout << endl;
    }
    while ( c!=last );

    cout << endl;
}
// -------------------------

int
main(int argc, char **argv)
{
    ulong n = 7, k = 4;
    if ( argc>1 )  n = atol(argv[1]);
    if ( argc>2 )  k = atol(argv[2]);

    foo(n, k);

    return 0;
}
// -------------------------
