
#include "comb/compositionlex.h"
#include "bits/bit2composition.h"

#include "bits/printbin.h"
#include "demo/nextarg.h"

#include "fxttypes.h"
#include "fxtio.h"

#include <cstdlib> // atol()

//% Generating all compositions in lexicographic order.


int
main(int argc, char **argv)
{
    ulong n = 5;
    NXARG(n, "compositions of n >=1 ...");

    ulong k = 3;
    NXARG(k, " ... into k >=1 parts.");

    composition_lex p(n, k);
    ulong wn = n+k-1;
    const ulong *x = p.data();
    ulong ct = 0;
    do
    {
        cout << " #"; cout.width(3); cout << ct << ":   ";
        for (ulong i=0; i<k; ++i)  cout << x[i] << " ";
        ulong w = composition2bit(x, wn);
        print_binv_nn("   ", w, wn);
        cout << endl;

        ++ct;
    }
    while ( p.next() );

    cout << "  #= " << ct << endl;

    return 0;
}
// -------------------------

