
#include "bits/graycode.h"
#include "bits/parity.h"

#include "bits/bitcount.h"

#include "bits/printbin.h"
#include "fxttypes.h"

#include "fxtio.h"

#include <cstdlib> // atol()

//% Demo of the binary Gray code.

int
main(int argc, char **argv)
{
    ulong n = 64;
    if ( argc>1 )  n = atol(argv[1]);

    cout << "      v             gray_code(v)    bits/sorted   inverse_gray_code(v)/parity(v)"
         << endl;

    for (ulong v=0; v<n; ++v)
    {
        print_bin_nn("", v, 8);
        cout << " = ";
        cout.width(3); cout << v;
        cout << "     ";

        ulong g = gray_code(v);
        cout.width(3); cout << g;
        cout << " = ";
        print_bin_nn("", g, 8);
        cout << "     ";

        ulong bc = (1UL<<bit_count(g))-1;
        print_bin_nn("", bc, 8);
        cout << "     ";

        ulong i = inverse_gray_code(v);
        print_bin_nn("", i, 8);
        cout << " = ";
        cout.width(3); cout << i;

        cout << "      P= ";
        cout << parity(v);
        cout << endl;
    }

    return 0;
}
// -------------------------
