
#include "bits/bitcombcolex.h" // first_comb()
#include "bits/bitlow.h" // lowest_bit()
#include "bits/printbin.h"


#include "fxtiomanip.h"

#include "demo/nextarg.h"


//% Towers of Hanoi puzzle.


void
print_hanoi(const ulong *f, ulong ldn, ulong s)
{
    // print the towers:
    for (ulong j=0; j<3; ++j)  print_bin_nn("  ", f[j], ldn, ".1");

    // print move:
    print_bin_nn("    ", s, ldn, ".1");

    // print summary:
    cout << "   ";
//    for (ulong k=0, b=1;  k<ldn;  ++k ,b<<=1)
    for (ulong k=ldn-1,b=1<<(ldn-1);  0!=b;  --k,b>>=1)
    {
        cout << ' ';
        if ( b & f[0] )  cout << '0';
        else
        {
            if ( b & f[1] )  cout << '+';
            else             cout << '-';
        }
    }
    cout << endl;
}
// -------------------------

void
hanoi(ulong ldn)
{
    ulong f[3];
    for (ulong k=0; k<3; ++k)  f[k] = 0;
    f[0] = first_comb(ldn);
    ulong n = 1UL<<ldn;

    print_hanoi(f, ldn, 0);
    ulong u = 2;  // index of tower untouched in current move
    for (ulong k=1; k<n; ++k)
    {
        ulong s = lowest_bit(k);

        ulong j = 3;
        while ( j-- )  f[j] ^= s;
        f[u] ^= s;

        if ( --u > 2 )  u = 2;  // modulo 3

        print_hanoi(f, ldn, s);
    }
}
// -------------------------


int
main(int argc, char **argv)
{
    ulong ldn = 5;
    NXARG(ldn, "Number of disks");
    ulong n = 1UL << ldn;
    cout << "  ldn=" << ldn << "  n=" << n << endl;

    hanoi(ldn);

    return  0;
}
// -------------------------
