
// demo-include "mod/kronecker.cc"

#include "mod/mod.h"

#include "fxtiomanip.h"
#include "jjassert.h"
#include "demo/nextarg.h"

//% Kronecker symbol.


int
main(int argc, char **argv)
{
    ulong ma = 40;
    NXARG(ma," maximum a in kronecker(a,b)")
    ulong mb = 20;
    NXARG(mb," maximum b in kronecker(a,b)")

    cout << "b\\a";
    for (ulong a=0; a<=ma; a+=2)
    {
        cout.width(4); cout << a;
    }
    cout << endl;

    ulong b = mb+1;
    do
    {
        --b;
        cout.width(3); cout << b << ": ";
        for (ulong a=0; a<=ma; ++a)
        {
            int k = kronecker(a, b);
            cout << " ";
//            cout << k;
            cout << (-1==k ? "-" : (+1==k ? "+" : "0"));
            jjassert( abs(k)<=1 );
            
        }
        cout << endl;
    }
    while ( b!=0 );
    cout << endl;

    return 0;
}
// -------------------------

// pari/gp:
// ? mb=20;ma=40;
// ? { forstep(b=mb,0,-1,print1(b);for(a=0,ma,k=kronecker(a,b);
//     print1(" ");print1(if(-1==k,"-",if(+1==k,"+",k))));print();); }
//
// b\a  0   2   4   6   8  10  12  14  16  18  20  22  24  26  28  30  32  34  36  38  40
//   20 0 + 0 - 0 0 0 - 0 + 0 + 0 - 0 0 0 - 0 + 0 + 0 - 0 0 0 - 0 + 0 + 0 - 0 0 0 - 0 + 0
//   19 0 + - - + + + + - + - + - - - - + + - 0 + - - + + + + - + - + - - - - + + - 0 + -
//   18 0 + 0 0 0 - 0 + 0 0 0 - 0 - 0 0 0 + 0 - 0 0 0 + 0 + 0 0 0 - 0 + 0 0 0 - 0 - 0 0 0
//   17 0 + + - + - - - + + - - - + - + + 0 + + - + - - - + + - - - + - + + 0 + + - + - -
//   16 0 + 0 + 0 + 0 + 0 + 0 + 0 + 0 + 0 + 0 + 0 + 0 + 0 + 0 + 0 + 0 + 0 + 0 + 0 + 0 + 0
//   15 0 + + 0 + 0 0 - + 0 0 - 0 - - 0 + + 0 + 0 0 - + 0 0 - 0 - - 0 + + 0 + 0 0 - + 0 0
//   14 0 + 0 + 0 + 0 0 0 + 0 - 0 + 0 + 0 - 0 + 0 0 0 + 0 + 0 + 0 - 0 - 0 - 0 0 0 - 0 + 0
//   13 0 + - + + - - - - + + - + 0 + - + + - - - - + + - + 0 + - + + - - - - + + - + 0 +
//   12 0 + 0 0 0 - 0 + 0 0 0 - 0 + 0 0 0 - 0 + 0 0 0 - 0 + 0 0 0 - 0 + 0 0 0 - 0 + 0 0 0
//   11 0 + - + + + - - - + - 0 + - + + + - - - + - 0 + - + + + - - - + - 0 + - + + + - -
//   10 0 + 0 + 0 0 0 - 0 + 0 - 0 + 0 0 0 - 0 - 0 - 0 - 0 0 0 + 0 - 0 + 0 - 0 0 0 + 0 + 0
//    9 0 + + 0 + + 0 + + 0 + + 0 + + 0 + + 0 + + 0 + + 0 + + 0 + + 0 + + 0 + + 0 + + 0 +
//    8 0 + 0 - 0 - 0 + 0 + 0 - 0 - 0 + 0 + 0 - 0 - 0 + 0 + 0 - 0 - 0 + 0 + 0 - 0 - 0 + 0
//    7 0 + + - + - - 0 + + - + - - 0 + + - + - - 0 + + - + - - 0 + + - + - - 0 + + - + -
//    6 0 + 0 0 0 + 0 + 0 0 0 + 0 - 0 0 0 - 0 - 0 0 0 - 0 + 0 0 0 + 0 + 0 0 0 + 0 - 0 0 0
//    5 0 + - - + 0 + - - + 0 + - - + 0 + - - + 0 + - - + 0 + - - + 0 + - - + 0 + - - + 0
//    4 0 + 0 + 0 + 0 + 0 + 0 + 0 + 0 + 0 + 0 + 0 + 0 + 0 + 0 + 0 + 0 + 0 + 0 + 0 + 0 + 0
//    3 0 + - 0 + - 0 + - 0 + - 0 + - 0 + - 0 + - 0 + - 0 + - 0 + - 0 + - 0 + - 0 + - 0 +
//    2 0 + 0 - 0 - 0 + 0 + 0 - 0 - 0 + 0 + 0 - 0 - 0 + 0 + 0 - 0 - 0 + 0 + 0 - 0 - 0 + 0
//    1 + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + + +
//    0 0 + 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0
