
#include "bpol/lhca.h"
#include "bpol/bitpolirred.h"
//#include "bpol/minweightlhcarule.cc"

//#include "bpol/bitpolprimitive.h"  // test needs factorization

#include "bits/printbin.h"

#include "jjassert.h"
#include "fxtiomanip.h"

#include "fxttypes.h"
#include "bits/bitsperlong.h"

#include <cstdlib>  // atol()

//% Convert LHCA rules to binary polynomials.


int
main(int argc, char **argv)
{
    ulong n = BITS_PER_LONG - 1;
    if ( argc>1 )  n = atol(argv[1]);
    ulong pn  = n + 1;

    cout.width(pn);  cout << "LHCA rule";
    cout.width(pn);  cout << "polynomial";
    cout << endl;

    ulong h = 1;
    for (ulong k=1; k<=n; ++k)
    {
        cout.width(2);  cout << k << ":  ";

        ulong c = minweight_lhca_rule[k];
//        c = revbin(c, k);  // verify that poly for reversed LHCA rule is identical
//        c = ~c;
        print_bin_nn("  ", c, pn);
//        cout << "  == 0x" << hex << c << dec;// << endl;
//        cout << "  length=" << (n) << endl;

        ulong p = lhca2poly(c, k);
        print_bin_nn("   ", p, pn);

        ulong iq = bitpol_irreducible_q(p, h);
        jjassert( iq );

//        ulong pq = bitpol_primitive_q(p, h);
//        jjassert( pq );

        h <<= 1;

        cout << endl;
    }

    return 0;
}
// -------------------------

