
#include "bits/negbin.h"
#include "bits/graycode.h"

//#include "bits/bitlow.h"
#include "bits/printbin.h"

#include "fxtiomanip.h"
#include "jjassert.h"

#include <cstdlib>  // atol()


//% Representation in radix(-2), see HAKMEM item 128.


int
main(int argc, char **argv)
{
    ulong ldn = 5;
    if ( argc>1 )  ldn = atol(argv[1]);
    ulong n = 1UL<<ldn;
    ulong pn = ldn+2;

    ulong gg = 0;
    cout << setw(3+2) << " k : ";
    cout << setw(pn+2) << "bin(k)";
    cout << setw(pn+2) << "gray(k)";
    cout << "  ";
    cout << setw(pn+2) << "m=negbin(k)";
    cout << setw(pn+2) << "gray(m)";
    cout << setw(3+2) << "  : k";
    cout << endl;

    for (ulong k=0; k<n; ++k)
    {
        cout << setw(3) << k;
        print_bin_nn(" : ",k,pn);
        ulong gk = gray_code(k);
        print_bin_nn("  ",gk,pn);
//        print_bin_nn("  ",lowest_bit(k),pn);

        ulong m = k;
        m = bin2neg(m);
        cout << "  ";
        print_bin_nn("  ",m,pn);
        ulong gm = gray_code(m);
        print_bin_nn("  ",gm,pn);
//        print_bin_nn("  ",gm^gg,pn);
        gg = gm;

        jjassert( neg2bin(m) == k );

        cout << "     :" << setw(3) << k;
        cout << endl;
    }

    cout << endl;

    return 0;
}
// -------------------------
