
#include "perm/permvisit.h"
#include "perm/permutation.h"

#include "fxttypes.h"
#include "fxtio.h"
#include "jjassert.h"

#include <cstdlib> // atol()

//% Generate all permutations in graph-traversal order.

#define SHOW_INVERSE  // define to also print inverse permutations

int
main(int argc, char **argv)
{
    ulong n = 4;
    if ( argc>1 )  n = atol(argv[1]);

    perm_visit perm(n);
    const ulong *x = perm.data();
    do
    {
        cout << " #"; cout.width(3); cout << perm.current() << ":   ";
        for (ulong i=0; i<n; ++i)  cout << x[i] << " ";

#ifdef SHOW_INVERSE
        const ulong *xi = perm.idata();
        cout << "    inv= ";
        for (ulong i=0; i<n; ++i)  cout << xi[i] << " ";
        jjassert( is_inverse( x, xi, n) );
#endif

        cout << endl;
    }
    while ( perm.next() );

    return 0;
}
// -------------------------


