################## FXT files.mk ##########################

#-------------------------------------

TMPDIR=/tmp
TMP1=$(TMPDIR)/tmp1
TMP2=$(TMPDIR)/tmp2
TMP3=$(TMPDIR)/tmp3

#-------------------------------------

FXTLIB=libfxt.a
LIBS = $(FXTLIB) $(PPLIBS)

SCRIPTDIR=./scripts

FXTIDIR= ./include

NONSRCDIRS= \
./data \
./demo \
./doc \
./include \
./scripts \
./simplfft \
./test \

FXTSRCDIRS= \
./aux0 \
./aux1 \
./aux2 \
./bits \
./bpol \
./bmat \
./chirpzt \
./comb \
./graph \
./convolution \
./correlation \
./dctdst \
./ds \
./fft \
./fht \
./haar \
./matrix \
./matrixfft \
./mod \
./mult \
./ntt \
./perm \
./realfft \
./sort \
./walsh \
./wavelet \

FXTHDRS=$(shell find $(FXTSRCDIRS) $(FXTIDIR) -maxdepth 1 -name \[a-zA-Z]\*.h)

#-------------------------------------


AUXOBJS= \
bits/hilbert.o \
bits/tinyfactors.o \
bits/printbin.o \
\
bpol/bitpolprint.o \
bpol/gf2ntrace.o \
bpol/gf2norder.o \
bpol/gf2n.o \
bpol/randprimpoly.o \
bpol/lowbitprimpoly.o \
bpol/minweightprimpoly.o \
bpol/highbitnormalpoly.o \
bpol/highbitnormalprimpoly.o \
bpol/solvequadratic.o \
bpol/minpoly.o \
bpol/minweightlhcarule.o \
bpol/normalmult.o \
bpol/normalsolvequadratic.o \
bpol/bitpolsquarefree.o \
bpol/bitpolnormal.o \
bpol/numofbitpol.o \
bpol/berlekamp.o \
bpol/bitpolfactor.o \
\
bmat/bitmatmult.o \
bmat/bitmatinverse.o \
bmat/bitmatnullspace.o \
bmat/bitmathessenberg.o \
bmat/bitmatcharpoly.o \
bmat/bitmatcompanion.o \
bmat/bitmatkronecker.o \
bmat/bitmatprint.o \
\
aux0/rand.o \
aux0/aux0double.o \
aux0/aux0print.o \
aux0/jjassert.o \
aux0/sincos.o \
aux0/version.o \
\
aux1/bytescan.o \
aux1/resample.o \
aux1/str2ulong.o \
aux1/symmetry.o \
aux1/aux1double.o \
aux1/printset.o \
aux1/auxprint.o \
aux1/trigtable.o \
\
aux2/array2d.o \
sort/sortcomplex.o \
sort/radixsort.o \
ds/bitarray.o \

COMBOBJS= \
perm/revbinpermute.o \
perm/zip.o \
perm/radixpermute.o \
perm/permtrotter.o \
perm/permderange.o \
perm/permminchange.o \
perm/permstar.o \
perm/permvisit.o \
perm/permlex.o \
perm/permutationq.o \
perm/printperm.o \
perm/permutation.o \
perm/cycles.o \
perm/permrecognize.o \
\
comb/paren.o \
comb/partition.o \
comb/comblex.o \
comb/combcolex.o \
comb/combminchange.o \
comb/combaltminchange.o \
comb/delta2gray.o \
comb/monotonicgray.o \
comb/acgray.o \
comb/testgray.o \
comb/printgray.o \
comb/stringsubst.o \
comb/numofnecklaces.o \
\
graph/digraph.o \
graph/digraphpaths.o \
graph/digraphpaths-search.o \
graph/printpath.o \
graph/digraphfull.o \
graph/digraphdebruijn.o \
graph/digraphgray.o \
graph/digraphlyndongray.o \
graph/lyndoncmp.o \


FFTOBJS= \
fft/fftdit2.o \
fft/fftdif2.o \
fft/fftdit4l.o \
fft/fftdif4l.o \
fft/fftdit4.o \
fft/cfftdit4.o \
fft/fftdif4.o \
fft/cfftdif4.o \
fft/fft8ditcore.o \
fft/fft8difcore.o \
fft/fft9.o \
fft/fftsplitradix.o \
fft/cfftsplitradix.o \
fft/fhtfft.o \
fft/fhtcfft.o \
fft/fftspect.o \
fft/fouriershift.o \
fft/skipfft.o \
fft/twodimfft.o \
fft/ndimfft.o \
fft/gfft.o \
fft/cfftwrap.o \
fft/slowft.o \
fft/recfft2.o \
fft/weightedfft.o \


CONVOBJS= \
convolution/fftcnvl.o \
convolution/fftcnvla.o \
convolution/fftcocnvl.o \
convolution/fhtcnvl.o \
convolution/cfhtcnvl.o \
convolution/fhtcnvla.o \
convolution/cfhtcnvla.o \
convolution/fhtnegacnvl.o \
convolution/fhtnegacnvla.o \
convolution/twodimfhtcnvl.o \
convolution/slowcocnvl.o \
convolution/weightedconv.o \

CORROBJS= \
correlation/fftcocorr.o \
correlation/fftcorr.o \
correlation/fhtcorr.o \
correlation/slowcocorr.o \


REALFFTOBJS= \
realfft/realfftbyfht.o \
realfft/realfftwrap.o \
realfft/realffteasyord.o \
realfft/realfftsplitradix.o \
realfft/skiprealfft.o \

OTHERFFTOBJS= \
chirpzt/fftarblen.o \
chirpzt/fftfract.o \
chirpzt/makechirp.o \
chirpzt/slowfracft.o \
chirpzt/slowzt.o \


MATRIXFFTOBJS= \
matrixfft/columnffts.o \
matrixfft/rowffts.o \
matrixfft/rowcnvls.o \
matrixfft/matrixfft.o \
matrixfft/matrixfftcnvl.o \
matrixfft/matrixfftcnvla.o \
matrixfft/matrixfftcocnvla.o \

FHTOBJS= \
fht/fhtdit2.o \
fht/fhtdif2.o \
fht/fhtdit.o \
fht/fhtdif.o \
fht/cfhtdit.o \
fht/cfhtdif.o \
fht/fht0.o \
fht/cfht0.o \
fht/fhttable.o \
fht/fhtspect.o \
fht/hartleyshift.o \
fht/skipfht.o \
fht/twodimfht.o \
fht/slowht.o \
fht/recfht2.o \

DCTDSTOBJS= \
dctdst/cosrot.o \
dctdst/dcth.o \
dctdst/dct4.o \
dctdst/dct.o \
dctdst/dctzapata.o \
dctdst/dsth.o \
dctdst/dst.o \

WALSHOBJS= \
walsh/slant.o \

HAAROBJS= \
haar/haari2i.o \

WAVELETOBJS= \
wavelet/wavelet.o \
wavelet/invwavelet.o \
wavelet/waveletfilter.o \
wavelet/harmonicwavelet.o \

FXTMULTOBJS = \
mult/auxil.o \
mult/workspace.o \
mult/carry.o \
mult/fxtmult.o \
mult/fxtsquare.o \
mult/fxtmultiply.o \
mult/diskaux.o \
mult/diskaux2.o \
mult/diskrowpass.o \
mult/diskcolpass.o \
mult/diskcnvla.o \
mult/disksquare.o \
mult/diskmultiply.o \

MODOBJS= \
mod/mod.o \
mod/modinit.o \
mod/modinfo.o \
mod/maxorder.o \
mod/primes.o \
mod/perfpow.o \
mod/erastothenes.o \
mod/order.o \
mod/factor.o \
mod/factormake.o \
mod/cyclic.o \
mod/chinese.o \
mod/quadresidue.o \
mod/sqrtmod.o \
mod/kronecker.o \
mod/rabinmiller.o \
mod/phi.o \
mod/mersenne-exponents.o \
mod/mersenne-factors.o \
mod/mersenne-generators.o \
mod/testnum.o \
mod/chebyshev.o \

NTTOBJS= \
ntt/nttdit2.o \
ntt/nttdif2.o \
ntt/nttdif2nc.o \
ntt/nttdit4.o \
ntt/nttdif4.o \
ntt/nttlearn.o \
ntt/nttcnvl.o \
ntt/slownttcnvl.o \
ntt/slowntt.o \

#
OBJS =
OBJS += $(AUXOBJS)
OBJS += $(COMBOBJS)
OBJS += $(FFTOBJS)
OBJS += $(REALFFTOBJS)
OBJS += $(FHTOBJS)
OBJS += $(OTHERFFTOBJS)
OBJS += $(MATRIXFFTOBJS)
#OBJS += $(MATRIXOBJS)
OBJS += $(DCTDSTOBJS)
OBJS += $(CONVOBJS)
OBJS += $(CORROBJS)
OBJS += $(WALSHOBJS)
OBJS += $(HAAROBJS)
OBJS += $(WAVELETOBJS)
OBJS += $(WEIGHTEDOBJS)
OBJS += $(FXTMULTOBJS)
OBJS += $(MODOBJS)
OBJS += $(NTTOBJS)


#
SRC=$(OBJS:.o=.cc)

#-------------------------------------

################## end FXT files.mk ##########################
