
#include "fxttypes.h"
#include "perm/permminchange.h"
#include "aux0/inline.h"


#include "aux0/inline.h"

perm_minchange::perm_minchange(ulong nn)
{
    n_ = ( nn<1 ? 1 : nn );
    p_  = new ulong[4*n_];
    ip_ = p_ + n_;
    d_  = ip_ + n_;
    ii_ = d_ + n_;
    first();
}
// -------------------------

perm_minchange::~perm_minchange()
{
    delete [] p_;
}
// -------------------------


void
perm_minchange::first()
{
    for (ulong i=0; i<n_; i++)
    {
        p_[i] = ip_[i] = i;
        d_[i] = -1UL;
        ii_[i] = 0;
    }
    sw1_ = sw2_ = 0;
    idx_ = 0;
}
// -------------------------


ulong
perm_minchange::make_next(ulong m)
{
    ulong i = ii_[m];
    ulong ret = 1;

    if ( i==m )
    {
        d_[m] = -d_[m];
        if ( 0!=m )  ret = make_next(m-1);
        else         ret = 0;
        i = -1UL;
    }

    if ( (long)i>=0 )
    {
        // this block based on code by
        // Frank Ruskey / Glenn Rhoads:
        ulong j = ip_[m];
        ulong k = j + d_[m];
        ulong z = p_[k];
        p_[j] = z;
        p_[k] = m;
        ip_[z] = j;
        ip_[m] = k;

        sw1_ = j;  // note that sw1_ == sw2_ +-1 (adjacent positions)
        sw2_ = k;
        ++idx_;
    }

    ++i;
    ii_[m] = i;

    return  ret;
}
// -------------------------
