#! /usr/bin/env bash


DEMOBIN=./bin
#RUNDEMO=$DEMOBIN
TMPDIR=/tmp
DTMP=$TMPDIR/tmp-demo
DEMODIR=./demo
MAKE=make


test -n "$WHICH" || WHICH=all

#set -vx

rm -f $DTMP;
for f in $(echo $DEMODIR/*-demo.cc); do
    echo $f >>  $DTMP;
done

if [ "$WHICH" = "all" ]; then DSRC=$(<$DTMP); fi;

if [ "$WHICH" = "header" ]; then
    if [ -z "$PAT" ]; then echo "Empty pattern"; exit 1; fi;
    DSRC=$(grep -lE -- "\#include[ ]+.*$PAT" $DEMODIR/*-demo.cc);
    if [ -z "$DSRC" ]; then echo "Pattern did not match"; fi;
fi;

if [ "$WHICH" = "grep" ]; then
    if [ -z "$PAT" ]; then echo "Empty pattern"; exit 1; fi;
    DSRC=$(grep -lE -- "$PAT" $DEMODIR/*-demo.cc);
    if [ -z "$DSRC" ]; then echo "Pattern did not match"; fi;
fi;


if [ "$WHICH" = "files" ]; then
    if [ -z "$PAT" ]; then echo "Empty pattern"; exit 1; fi;
    DSRC=$(grep -E -- ".*$PAT" $DTMP);
    if [ -z "$DSRC" ]; then echo "Pattern did not match"; fi;
fi;

if [ "$WHICH" = "nt" ]; then
    DSRC='';
    for f in $(<$DTMP); do
        OUT=$DEMODIR/$(basename $f -demo.cc)-out.txt;
        test $f -nt $OUT  ||  continue;
        DSRC="$DSRC $f";
    done;
fi;


#echo "DSRC=[[$DSRC]]"; exit
if [ -z "$DSRC" ]; then
    echo "Nothing to do.  (?)";
    exit 0;
fi;


DSRC=$(\ls -1t $DSRC); # time ordered

#set -vx
for f in $DSRC; do
    OUT=$DEMODIR/$(basename $f -demo.cc)-out.txt;
    echo -n "$f --> $OUT";
    $MAKE -s 1demo  DSRC=$f > $DTMP
    if [ "$?" != "0" ]; then
        test -n "$DEMO_KEEP_GOING" && continue;
        echo "OOPS !  check $DTMP"; ls -l $DTMP; exit 1;
    fi;
    if [ -f $OUT ]; then
        diff $DTMP $OUT &>/dev/null  || \
            { echo -n "  (CHANGED)";  cp -a $OUT $TMPDIR; } ## old version --> /tmp
    else
         echo -n "  (NEW)";
    fi;
    mv $DTMP $OUT;
    touch $OUT;
    echo;
done;



exit 0;
##############################
