#!/usr/bin/env bash

# author: Joerg Arndt
# version:  2003-December-07 (17:07)

#set -vx

JJTMP=/tmp/demo2web/
mkdir -p ${JJTMP}
rm -rf ${JJTMP:?}/*  ### !!!  RM  !!!
mkdir -p ${JJTMP}


#function pv () { true; }
#function pv () { for x in $*; do eval "echo $x==\$$x"; done }

test -n "$WEBDIR" || { echo " *** WEBDIR not set in environment." 1>&2; exit 1; }
test -d "$WEBDIR" || { echo " *** $WEBDIR: no such directory." 1>&2; exit 1; }

WEBLOC=$WEBDIR/fxt/demo/
test -d "$WEBLOC" || { echo " *** $WEBLOC: no such directory." 1>&2; exit 1; }

DSRC=demo/*-demo.cc
XDSRC=""
for f in $DSRC; do  XDSRC="$XDSRC $f"; done


############## generate html page:

#exec 1<>${JJTMP}/00main.html

cat <<EOF
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 3.2//EN">
<HTML>
<HEAD>
<TITLE>The fxt demos (generated webpage)</TITLE>
<META HTTP-EQUIV="Content-Type" content="text/html; charset=iso-8859-1">
<!-- GENERATED_FILE DEMO2WEB_MAGIC -->
</HEAD>
<BODY bgcolor="#fffff0" text="#000000">
<H1>The fxt demos (generated webpage)</H1>

Find a list of all files in this directory <a href="index.html">here</a>.
<P>

You may want to look at the outputs first.
<P>

EOF


ALLHDRS="";
for f in $XDSRC; do
    g=${f/-demo.cc/-out.txt}

    sf=${f#demo/}
    sg=${g#demo/}

    echo "<!-- ---------- $f ---------- -->";
    echo "<a href=\"$sg\">$sg</a> is the output of <a href=\"$sf\">$sf</a>.";
    echo '<BR>'
    echo "Description:  ";
    echo '<B>'
    grep -F '//%' $f | cut -d'%' -f2-
    echo '</B>'
    echo '<BR>'

    if grep -F 'demo-is-self-contained' $f >/dev/null ; then
        : # nothing
    else
        HDRS=$(perl scripts/firsthdrs.pl < $f);
        test -n "$HDRS" || { echo " *** firsthdrs.pl failed (?)" 1>&2;  exit 10; }
        echo "The demo uses the functions from "
        for h in $HDRS; do
#            hf=$(echo */$h);
            hf=$h
            h=$(basename $h)
            echo "<a href=\"$h\">$h</a> (fxt/$hf)";
            ALLHDRS="$ALLHDRS $hf";
        done
    fi
    echo '<P>'
done

SUHDRS=$(for h in $ALLHDRS; do echo $h; done | sort | uniq )
TT=""
for h in $SUHDRS; do
#    echo "<!-- $h -->";
    if ! test -f "$h"; then
        h=include/$h;
    fi
    test -f $h  ||  { echo " *** $h: no such file." 1>&2; exit 1;}
    TT="$h $TT";
done;
SUHDRS=$TT

XDOUT=${XDSRC//-demo.cc/-out.txt}


cat <<EOF
</BODY>
</HTML>
EOF


############## copying the files:

cp -a $SUHDRS $JJTMP
cp -a $XDSRC  $JJTMP
cp -a $XDOUT  $JJTMP



exit 0;
#############################
